using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication2
{
    public partial class Form1 : Form
    {
        int c;
        byte[] row0 = new byte[30];                 // Marquee Text string array
        byte[] lcd_row0 = new byte[16];             // Text string to LCD
        byte[] lcd_command = { 11,12,13,254,45,1};  // LCD command bytes
        string marqueeText0;                        // Marquee Text on row 0
        string row1text;                            // Fixed text on row 1

        public Form1()
        {
            int b;

            InitializeComponent();
            for (b = 0; b < 16; b++)                // Fill the LCD row byte array with spaces
            {
                lcd_row0[b] = 32;
            }
            serialPort1.BaudRate = 9600;
            serialPort1.PortName = "COM1";
            serialPort1.Open();
            serialPort1.Write(lcd_command, 2, 1);   // Send LCD Clear command , 13
        }

        private void button1_Click(object sender, EventArgs e)
        {
            marqueeText0 = textBox1.Text;
            row0 = StrToByteArray(marqueeText0);    // Convert Marquee text to string array
            c = 0;
            timer1.Enabled = true;                  // Initiate marquee timer
            button1.Enabled = false;                // Disable start button
            button2.Enabled = true;                 // Enable stop button
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int a;

            for (a = 0; a < 15; a++)                // fill the lcd_row array with text array
            {
                lcd_row0[a] = lcd_row0[a + 1];      // every 500 ms
            }
            lcd_row0[15] = row0[c];                 // 
            c++;
            if (c == marqueeText0.Length)
            {
                c = 0;
            }
            serialPort1.Write(lcd_command, 0, 1);   // LCD cursor home command , 11
            serialPort1.Write(lcd_row0, 0, 16);     // Send the 16 bytes lcd_row0 to LCD
            
        }
        private static byte[] StrToByteArray(string str)
        {
            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
            return encoding.GetBytes(str);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;                             // stop text marquee
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            row1text = textBox2.Text;               
            if (row1text.Length != 0)                       // If textbox2 not empty
            {
                serialPort1.Write(lcd_command, 3, 3);       // Clear row 1
                serialPort1.Write(row1text);                // Send the text to LCD
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            serialPort1.Write(lcd_command, 3, 3);           // Clear row 1
        }
        
       
    }
}